/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/
/*
 * HISTORY
 * $Log: CxxXmString.h,v $
 * Revision 1.1.1.1  1994/08/30  18:48:41  craig
 * OSF/Motif 2.0
 *
 * Revision 1.1.2.3  1993/12/08  23:42:14  yak
 * 	Changed comment leader. Expended copyright. CR 7534
 * 	[1993/12/08  22:58:54  yak]
 *
 * Revision 1.1.2.2  1993/09/23  17:39:57  drand
 * 	Initial revision.
 * 	[1993/09/23  17:39:00  drand]
 * 
 * $EndLog$
*/
/*   $RCSfile: CxxXmString.h,v $ $Revision: 1.1.1.1 $ $Date: 1994/08/30 18:48:41 $ */

// Wrapper for XmString objects

class XmCxxString {
private:
  XmString	internal;
public:
      // Constructors
  XmCxxString(const char* str) { 
    internal = XmStringCreateLocalized((String) str); 
  };
  XmCxxString(XmCxxString &str) { internal = XmStringCopy(str.internal); }
  XmCxxString(XmString str) { internal = str; }
  XmCxxString() { internal = XmStringCreateLocalized((String) ""); }
  static XmCxxString& Separator() {
    XmCxxString *n;
    n = new XmCxxString(XmStringSeparatorCreate());
    return *n;
  }
      // Destructor
  ~XmCxxString() { XmStringFree(internal); }
      // Operators + (concat), = and ==
  XmCxxString& operator=(const char *s) {
    XmStringFree(internal);
    internal = XmStringCreateLocalized((String) s);
    return *this;
  }
  XmCxxString& operator=(const XmString s) {
    XmStringFree(internal);
    internal = s;
    return *this;
  }
  XmCxxString& operator=(const XmCxxString &s) {
    XmStringFree(internal);
    internal = XmStringCopy(s.internal);
    return *this;
  }
  friend Boolean operator== (XmCxxString &x, XmCxxString &y) {
    return XmStringCompare(x.internal, y.internal);
  }
  friend XmCxxString& operator+(XmCxxString &x, XmCxxString &y);
  friend XmCxxString& operator+(XmCxxString &x, char *y);
  operator XmString() { return internal; }
      // Accessors and Functions
  Dimension 	baseline(XmRenderTable tab);
  Boolean 	empty() { return XmStringEmpty(internal); }
  void 		draw(Widget w, XmRenderTable r, GC gc, 
		     Position x, Position y, Dimension width, 
		     unsigned char alignment, unsigned char layout_dir,
		     XRectangle *clip);
  void 		draw(Display *d, Window w, XmRenderTable r, GC gc, 
		     Position x, Position y, Dimension width, 
		     unsigned char alignment, unsigned char layout_dir,
		     XRectangle *clip);
  void		extents(XmRenderTable r, Dimension *w, Dimension *h);
  Boolean	hasSubstring(XmCxxString& ss) {
    return XmStringHasSubstring(internal, ss.internal);
  }
  int		length() { return XmStringLength(internal); }
  int		lineCount() { return XmStringLineCount(internal); }
};



