#!/bin/sh

INSTALLDIR=/usr/X11R6/lib
INCLUDEDIR=/usr/X11R6/include
BINDIR=/usr/X11R6/bin

echo "Installing window manager in $BINDIR..."
cp bin/mwm $BINDIR
chmod 755 $BINDIR/mwm

echo "Installing libraries in $INSTALLDIR..."
cp lib/libXm.so.2.0 $INSTALLDIR
chmod 755 $INSTALLDIR/libXm.so.2.0
ln -sf $INSTALLDIR/libXm.so.2.0 $INSTALLDIR/libXm.so.2
ln -sf $INSTALLDIR/libXm.so.2.0 $INSTALLDIR/libXm.so

cp lib/libXm.a $INSTALLDIR
chmod 644 $INSTALLDIR/libXm.a

cp lib/libXmCxx.a $INSTALLDIR
chmod 644 $INSTALLDIR/libXmCxx.a

echo "Installing headers..."
mkdir -p /usr/X11R6/include/Mrm
mkdir -p /usr/X11R6/include/Xm
mkdir -p /usr/X11R6/include/XmCxx

cp include/Mrm/* $INCLUDEDIR/Mrm
cp include/Xm/* $INCLUDEDIR/Xm
cp include/XmCxx/* $INCLUDEDIR/XmCxx

echo "All done.  Run \"ldconfig\" as root now."

